"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Cart = void 0;
var ticketengine_sdk_1 = require("ticketengine-sdk");
var Model_1 = require("./Model");
var OrderValidator_1 = require("./OrderValidator");
var Cart = /** @class */ (function () {
    // constructor(salesChannelId: string, registerId: string, customerId?: string, clientId?: string, clientSecret?: string, scope?: string, authApiUrl?: string, adminApiUrl?: string, graphApiUrl?: string) {
    function Cart(options) {
        // salesChannelId: string;
        // registerId: string;
        // customerId?: string;
        // oauthClientId: string;
        // oauthClientSecret: string;
        // oauthScope: string;
        this.retryPolicy = [0, 500, 500, 500, 500, 500, 1000, 1000, 1000, 1000, 1000, 3000, 3000, 3000, 5000, 5000];
        // errorMessages: ErrorMessages = {};
        this.errorMessages = {};
        this.client = new ticketengine_sdk_1.WebClient({
            authUrl: options.authUrl || 'https://auth.ticketengine.io',
            adminApiUrl: options.adminApiUrl || 'https://admin-api.ticketengine.io',
            graphApiUrl: options.graphApiUrl || 'https://graph-api.ticketengine.io',
            oauthClientId: options.clientId || 'shopping_cart',
            oauthClientSecret: options.clientSecret || '',
            // oauthScope: options.scope || 'order:write payment:write event:read order:read order:reserve',
            oauthScope: options.scope || 'order:write payment:write event:read order:reserve',
            clearTokenOnSetAuthUrl: options.clearTokenOnSetAuthUrl || true,
        });
        // this.salesChannelId = options.salesChannelId;
        // this.registerId = options.registerId;
        // this.customerId = options.customerId;
        // this.oauthClientId = options.clientId || 'shopping_cart';
        // this.oauthClientSecret = options.clientSecret || '';
        // this.oauthScope = options.scope || 'order:write payment:write event:read order:read order:reserve';
        // const clientId =  options.clientId || 'shopping_cart';
        // const clientSecret = options.clientSecret || '';
        // const scope = options.scope || 'order:write payment:write event:read order:read order:reserve';
        // this.client.setClient(clientId, clientSecret);
        // this.client.setScope(scope);
        if (options.salesChannelId)
            this.setSalesChannelId(options.salesChannelId);
        if (options.registerId)
            this.setRegisterId(options.registerId);
        if (options.customerId)
            Cart.setCustomerId(options.customerId);
        if (options.preferredLanguageCode)
            this.setPreferredLanguageCode(options.preferredLanguageCode);
        if (options.errorMessages)
            this.setErrorMessages(options.errorMessages);
    }
    Cart.prototype.getClient = function () {
        return this.client;
    };
    Cart.prototype.login = function (username, password) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.client.user.getAuthToken({
                            grantType: 'password',
                            // clientId: this.oauthClientId,
                            // clientSecret: this.oauthClientSecret,
                            // scope: this.oauthScope,
                            clientId: this.client.getClientId(),
                            clientSecret: this.client.getClientSecret(),
                            scope: this.client.getScope(),
                            username: username,
                            password: password
                        })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Cart.prototype.isTokenExpired = function () {
        return this.client.isTokenExpired();
    };
    // public checkToken(): void {
    //     if(this.isTokenExpired()) {
    //
    //     }
    // }
    Cart.prototype.getEvent = function (eventId) {
        return __awaiter(this, void 0, void 0, function () {
            var query, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        query = "query { event(id: \"".concat(eventId, "\"){id,eventManagerId,name,description,location,start,end,totalCapacity,availableCapacity,capacityLocationSummery{capacityLocationPath,name,capacity,issued,reserved,granted,available,used,start,end},hasTimeslots} }");
                        return [4 /*yield*/, this.client.sendQuery(query)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response.data.event];
                }
            });
        });
    };
    Cart.prototype.getEventPrices = function (eventId, customerId, salesChannelId, preferredLanguageCode, capacityLocationPath) {
        if (customerId === void 0) { customerId = null; }
        if (salesChannelId === void 0) { salesChannelId = null; }
        if (preferredLanguageCode === void 0) { preferredLanguageCode = null; }
        if (capacityLocationPath === void 0) { capacityLocationPath = null; }
        return __awaiter(this, void 0, void 0, function () {
            var inFinalState, orderParam, _a, _b, _c, customerParam, salesChannelParam, preferredLanguageParam, capacityLocationPathParam, query, response;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        inFinalState = new OrderValidator_1.IsInFinalState();
                        _a = this.hasOrder();
                        if (!_a) return [3 /*break*/, 2];
                        _c = (_b = inFinalState).validate;
                        return [4 /*yield*/, this.getOrder(this.getOrderId())];
                    case 1:
                        _a = !_c.apply(_b, [_d.sent()]);
                        _d.label = 2;
                    case 2:
                        orderParam = _a ? ", orderId: \"".concat(this.getOrderId(), "\"") : '';
                        customerParam = this.hasCustomerId() ? ", customerId: \"".concat(this.getCustomerId(), "\"") : '';
                        customerParam = customerParam !== '' && customerId !== null ? ", customerId: \"".concat(customerId, "\"") : '';
                        salesChannelParam = salesChannelId !== null ? ", salesChannelId: \"".concat(salesChannelId, "\"") : '';
                        preferredLanguageParam = preferredLanguageCode !== null ? ", preferredLanguage: \"".concat(preferredLanguageCode, "\"") : '';
                        capacityLocationPathParam = capacityLocationPath !== null ? ", capacityLocationPath: \"".concat(capacityLocationPath, "\"") : '';
                        query = "query { eventPrices(eventId: \"".concat(eventId, "\"").concat(orderParam).concat(customerParam).concat(salesChannelParam).concat(preferredLanguageParam).concat(capacityLocationPathParam, "){conditionId,price,currency{code,name,exponent,symbol},limit,tax,description,conditionPath,accessDefinition{id,name,description,capacityLocations}} }");
                        return [4 /*yield*/, this.client.sendQuery(query)];
                    case 3:
                        response = _d.sent();
                        return [2 /*return*/, response.data.eventPrices];
                }
            });
        });
    };
    Cart.prototype.getProductDefinition = function (productDefinitionId) {
        return __awaiter(this, void 0, void 0, function () {
            var query, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        query = "query { productDefinition(id: \"".concat(productDefinitionId, "\"){id,name,description,apiConfig{... on CreditAccountApiConfig{source,currencyCode,amount}}} }");
                        return [4 /*yield*/, this.client.sendQuery(query)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response.data.productDefinition];
                }
            });
        });
    };
    Cart.prototype.getProductPrices = function (productDefinitionId, customerId, salesChannelId, preferredLanguageCode) {
        if (customerId === void 0) { customerId = null; }
        if (salesChannelId === void 0) { salesChannelId = null; }
        if (preferredLanguageCode === void 0) { preferredLanguageCode = null; }
        return __awaiter(this, void 0, void 0, function () {
            var inFinalState, orderParam, _a, _b, _c, customerParam, salesChannelParam, preferredLanguageParam, query, response;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        inFinalState = new OrderValidator_1.IsInFinalState();
                        _a = this.hasOrder();
                        if (!_a) return [3 /*break*/, 2];
                        _c = (_b = inFinalState).validate;
                        return [4 /*yield*/, this.getOrder(this.getOrderId())];
                    case 1:
                        _a = !_c.apply(_b, [_d.sent()]);
                        _d.label = 2;
                    case 2:
                        orderParam = _a ? ", orderId: \"".concat(this.getOrderId(), "\"") : '';
                        customerParam = this.hasCustomerId() ? ", customerId: \"".concat(this.getCustomerId(), "\"") : '';
                        customerParam = customerParam !== '' && customerId !== null ? ", customerId: \"".concat(customerId, "\"") : '';
                        salesChannelParam = salesChannelId !== null ? ", salesChannelId: \"".concat(salesChannelId, "\"") : '';
                        preferredLanguageParam = preferredLanguageCode !== null ? ", preferredLanguage: \"".concat(preferredLanguageCode, "\"") : '';
                        query = "query { productPrices(productDefinitionId: \"".concat(productDefinitionId, "\"").concat(orderParam).concat(customerParam).concat(salesChannelParam).concat(preferredLanguageParam, "){conditionId,price,currency{code,name,exponent,symbol},limit,tax,description,conditionPath,productDefinition{id,name,description}} }");
                        return [4 /*yield*/, this.client.sendQuery(query)];
                    case 3:
                        response = _d.sent();
                        return [2 /*return*/, response.data.productPrices];
                }
            });
        });
    };
    Cart.prototype.getCustomer = function (customerId) {
        return __awaiter(this, void 0, void 0, function () {
            var query, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        query = "query { customer(id: \"".concat(customerId, "\"){id,firstName,lastName,fullName,sortName,birthDate,gender,email,tags{id,name}} }");
                        return [4 /*yield*/, this.client.sendQuery(query, [])];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response.data.customer];
                }
            });
        });
    };
    Cart.prototype.getOrderMessages = function (stage, orderId, eventId, productDefinitionId, customerId, salesChannelId, preferredLanguageCode) {
        if (customerId === void 0) { customerId = null; }
        if (salesChannelId === void 0) { salesChannelId = null; }
        if (preferredLanguageCode === void 0) { preferredLanguageCode = null; }
        return __awaiter(this, void 0, void 0, function () {
            var orderParam, eventParam, productDefinitionParam, customerParam, salesChannelParam, preferredLanguageParam, query, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        orderParam = orderId !== null ? ", orderId: \"".concat(orderId, "\"") : '';
                        eventParam = eventId !== null ? ", eventId: \"".concat(eventId, "\"") : '';
                        productDefinitionParam = productDefinitionId !== null ? ", productDefinitionId: \"".concat(productDefinitionId, "\"") : '';
                        customerParam = customerId !== null ? ", customerId: \"".concat(customerId, "\"") : '';
                        salesChannelParam = salesChannelId !== null ? ", salesChannelId: \"".concat(salesChannelId, "\"") : '';
                        preferredLanguageParam = preferredLanguageCode !== null ? ", preferredLanguage: \"".concat(preferredLanguageCode, "\"") : '';
                        query = "query { orderMessage(stage: \"".concat(stage, "\"").concat(orderParam).concat(eventParam).concat(productDefinitionParam).concat(customerParam).concat(salesChannelParam).concat(preferredLanguageParam, "){id,message}}");
                        return [4 /*yield*/, this.client.sendQuery(query, [])];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response.data.orderMessage];
                }
            });
        });
    };
    Cart.prototype.getOffers = function (orderId, customerId, salesChannelId, preferredLanguageCode) {
        if (customerId === void 0) { customerId = null; }
        if (salesChannelId === void 0) { salesChannelId = null; }
        if (preferredLanguageCode === void 0) { preferredLanguageCode = null; }
        return __awaiter(this, void 0, void 0, function () {
            var customerParam, salesChannelParam, preferredLanguageParam, query, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        customerParam = customerId ? ", customerId: \"".concat(customerId, "\"") : '';
                        salesChannelParam = salesChannelId ? ", salesChannelId: \"".concat(salesChannelId, "\"") : '';
                        preferredLanguageParam = preferredLanguageCode ? ", preferredLanguage: \"".concat(preferredLanguageCode, "\"") : '';
                        query = "query { offers(orderId: \"".concat(orderId, "\"").concat(customerParam).concat(salesChannelParam).concat(preferredLanguageParam, "){id,name,price,tax,limit,currencyCode,currency{code,name,exponent,symbol},taxes{value,type,description}}}");
                        return [4 /*yield*/, this.client.sendQuery(query, [])];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response.data.offers];
                }
            });
        });
    };
    Cart.prototype.getOrder = function (orderId, validator, retryPolicy, forceReload, forceOrder) {
        if (retryPolicy === void 0) { retryPolicy = []; }
        if (forceReload === void 0) { forceReload = false; }
        if (forceOrder === void 0) { forceOrder = false; }
        return __awaiter(this, void 0, void 0, function () {
            var order, message;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!forceReload) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.fetchOrder(orderId, validator, retryPolicy, forceOrder)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        order = localStorage.getItem("te-order");
                        if (!order) {
                            message = this.getErrorMessage('orderNotFound') || 'No order found.';
                            throw new Error(message);
                        }
                        return [2 /*return*/, JSON.parse(order)];
                }
            });
        });
    };
    Cart.prototype.fetchOrder = function (orderId, validator, retryPolicy, forceOrder) {
        if (retryPolicy === void 0) { retryPolicy = []; }
        if (forceOrder === void 0) { forceOrder = false; }
        return __awaiter(this, void 0, void 0, function () {
            var query, response, order, sleepTime, message, error_1, sleepTime;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 5, , 8]);
                        query = "query { me{order(id: \"".concat(orderId, "\"){id,status,number,email,customer{id,fullName,email},paymentStatus,paymentUrl,payments{id,currency{code,name,exponent,symbol},amount,status,psp,method},refunds{id,currency{code,name,exponent,symbol},amount,status,refundMethod},totalPrice,totalTax,createDate,expiresOn,tokens{id,typeId,token},requiredPayments{currency{code,name,exponent,symbol},amount},requiredLoyaltyCardPayments{currency{code,name,exponent,symbol},cardType,amount},lineItems{ ... on AccessLineItem {id,packageOrderLineItemId,type,status,price,tax,currency{code,name,exponent,symbol},limit,name,accessDefinition{id},capacityLocationPath,requestedConditionPath,accessId,access{id,tokens},event{id,eventManagerId,name,location,start,end,availableCapacity}} ... on ProductLineItem {id,packageOrderLineItemId,type,status,name,price,tax,currency{name,code,exponent,symbol},requestedConditionPath,productId,productDefinition{id,name,apiConfig{... on MembershipApiConfig{source}, ... on CreditAccountApiConfig{source}}},product{id,status}} },aggregatedLineItems{... on AggregatedAccessLineItem {id,type,orderLineItemIds,price,tax,totalPrice,totalTax,currency{name,code,exponent,symbol},limit,quantity,name,requestedConditionPath,capacityLocationPath,accessIds,event{id,eventManagerId,name,start,location,end,availableCapacity},accessDefinition{id,name}} ... on AggregatedProductLineItem {id,type,orderLineItemIds,price,tax,totalPrice,totalTax,currency{name,code,exponent,symbol},limit,quantity,name,requestedConditionPath,productIds,productDefinition{id,name,apiConfig{... on MembershipApiConfig{source}, ... on CreditAccountApiConfig{source}}}}}}} }");
                        return [4 /*yield*/, this.client.sendQuery(query, [])];
                    case 1:
                        response = _a.sent();
                        order = response.data.me.order;
                        // const order = forceOrder ? response.data.me.order : response.data.me.cart;
                        Cart.setOrder(order);
                        if (!(validator && !validator.validate(order))) return [3 /*break*/, 4];
                        sleepTime = retryPolicy.shift();
                        message = this.getErrorMessage('retryAttemptsExceeded') || 'Retry attempts exceeded.';
                        if (sleepTime === undefined)
                            throw new Error(message); // abort retry, retries attempts exceeded
                        return [4 /*yield*/, this.sleep(sleepTime)];
                    case 2:
                        _a.sent(); // wait x milliseconds
                        return [4 /*yield*/, this.fetchOrder(orderId, validator, retryPolicy)]; // retry
                    case 3: // wait x milliseconds
                    return [2 /*return*/, _a.sent()]; // retry
                    case 4: return [2 /*return*/, order];
                    case 5:
                        error_1 = _a.sent();
                        sleepTime = retryPolicy.shift();
                        if (sleepTime === undefined)
                            throw error_1; // abort retry, retries attempts exceeded
                        return [4 /*yield*/, this.sleep(sleepTime)];
                    case 6:
                        _a.sent(); // wait x milliseconds
                        return [4 /*yield*/, this.fetchOrder(orderId, validator, retryPolicy)]; // retry
                    case 7: // wait x milliseconds
                    return [2 /*return*/, _a.sent()]; // retry
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    Cart.prototype.createOrder = function () {
        return __awaiter(this, void 0, void 0, function () {
            var isPending, customerId, preferredLanguageCode, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        isPending = new OrderValidator_1.IsPending();
                        customerId = this.hasCustomerId() ? this.getCustomerId() : undefined;
                        preferredLanguageCode = this.hasPreferredLanguageCode() ? this.getPreferredLanguageCode() : undefined;
                        localStorage.removeItem("te-order");
                        return [4 /*yield*/, this.client.order.createOrder({ salesChannelId: this.getSalesChannelId(), registerId: this.getRegisterId(), customerId: customerId, preferredLanguageCode: preferredLanguageCode }, [0, 1000, 1000, 1000, 3000, 5000])];
                    case 1:
                        response = _a.sent();
                        return [4 /*yield*/, this.fetchOrder(response.data.orderId, isPending, __spreadArray([], this.retryPolicy, true))];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Cart.prototype.cancelOrder = function (orderId, reason) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!orderId) {
                            orderId = this.getOrderId();
                        }
                        return [4 /*yield*/, this.client.order.cancelOrder({ aggregateId: orderId, reason: reason }, __spreadArray([], this.retryPolicy, true))];
                    case 1:
                        _a.sent();
                        if (this.hasOrder() && this.getOrderId() === orderId) {
                            localStorage.removeItem("te-order");
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    Cart.prototype.cancelReservation = function (orderId, reason) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!orderId) {
                            orderId = this.getOrderId();
                        }
                        return [4 /*yield*/, this.client.order.cancelOrderReservation({ aggregateId: orderId, reason: reason }, __spreadArray([], this.retryPolicy, true))];
                    case 1:
                        _a.sent();
                        if (this.hasOrder() && this.getOrderId() === orderId) {
                            localStorage.removeItem("te-order");
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    Cart.prototype.addItems = function (items) {
        return __awaiter(this, void 0, void 0, function () {
            var isInFinalState, _a, _b, _c, _d, response, validatorItemsInFinalState, order, validatorAllItemsConfirmed, message;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        isInFinalState = new OrderValidator_1.IsInFinalState();
                        _a = !this.hasOrder();
                        if (_a) return [3 /*break*/, 3];
                        _b = this.hasOrder();
                        if (!_b) return [3 /*break*/, 2];
                        _d = (_c = isInFinalState).validate;
                        return [4 /*yield*/, this.getOrder(this.getOrderId())];
                    case 1:
                        _b = _d.apply(_c, [_e.sent()]);
                        _e.label = 2;
                    case 2:
                        _a = (_b);
                        _e.label = 3;
                    case 3:
                        if (!_a) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.createOrder()];
                    case 4:
                        _e.sent();
                        _e.label = 5;
                    case 5: return [4 /*yield*/, this.client.order.cartBatchOperation({
                            aggregateId: this.getOrderId(),
                            operations: this.mapToCartOperations(items)
                        }, __spreadArray([], this.retryPolicy, true))];
                    case 6:
                        response = _e.sent();
                        validatorItemsInFinalState = new OrderValidator_1.ItemsHaveStatusOneOf(response.data.orderLineItemIds, [Model_1.LineItemStatus.reserved, Model_1.LineItemStatus.removed]);
                        return [4 /*yield*/, this.fetchOrder(this.getOrderId(), validatorItemsInFinalState, __spreadArray([], this.retryPolicy, true))];
                    case 7:
                        order = _e.sent();
                        validatorAllItemsConfirmed = new OrderValidator_1.ItemsHaveStatusOneOf(response.data.orderLineItemIds, [Model_1.LineItemStatus.reserved]);
                        if (!validatorAllItemsConfirmed.validate(order)) {
                            message = this.getErrorMessage('couldNotAddItems') || 'Could not add items to cart.';
                            throw new Error(message); //
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    // private async addItem(item: AddItem): Promise<string> {
    //     let orderLineId = undefined;
    //
    //     if(Cart.isAccessCartItem(item)) {
    //         const response = await this.client.order.addAccessToCart({
    //             aggregateId: this.getOrderId(),
    //             eventManagerId: item.eventManagerId,
    //             eventId: item.eventId,
    //             accessDefinitionId: item.accessDefinitionId,
    //             // capacityLocationPath: cartItem.capacityLocationPath,
    //             requestedConditionPath: item.requestedConditionPath,
    //         }, this.retryPolicy);
    //         orderLineId = response.data.orderLineItemId;
    //     // } else if(Cart.isProductCartItem(item)) {
    //     } else {
    //         throw new Error('Cannot add item. Unknown item type.');
    //     }
    //
    //     return orderLineId;
    // }
    Cart.prototype.removeItems = function (items) {
        return __awaiter(this, void 0, void 0, function () {
            var validator;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // await Promise.all(items.map(item => {
                    //     return this.removeItem(item);
                    // }));
                    return [4 /*yield*/, this.client.order.cartBatchOperation({
                            aggregateId: this.getOrderId(),
                            operations: this.mapToCartOperations([], items)
                        }, __spreadArray([], this.retryPolicy, true))];
                    case 1:
                        // await Promise.all(items.map(item => {
                        //     return this.removeItem(item);
                        // }));
                        _a.sent();
                        validator = new OrderValidator_1.ItemsHaveStatus(items.map(function (i) { return i.orderLineItemId; }), Model_1.LineItemStatus.removed);
                        return [4 /*yield*/, this.fetchOrder(this.getOrderId(), validator, __spreadArray([], this.retryPolicy, true))];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    // private async removeItem(item: RemoveItem): Promise<RemoveItemFromCartResponse> {
    //     return this.client.order.removeItemFromCart({
    //         aggregateId: this.getOrderId(),
    //         orderLineItemId: item.orderLineItemId
    //     }, [...this.retryPolicy]);
    // }
    Cart.prototype.changeItems = function (addItems, removeItems) {
        if (addItems === void 0) { addItems = []; }
        return __awaiter(this, void 0, void 0, function () {
            var response, validator;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.client.order.cartBatchOperation({
                            aggregateId: this.getOrderId(),
                            operations: this.mapToCartOperations(addItems, removeItems)
                        }, __spreadArray([], this.retryPolicy, true))];
                    case 1:
                        response = _a.sent();
                        validator = new OrderValidator_1.ValidateItemsStatus(response.data.orderLineItemIds, removeItems.map(function (i) { return i.orderLineItemId; }));
                        return [4 /*yield*/, this.fetchOrder(this.getOrderId(), validator, __spreadArray([], this.retryPolicy, true))];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Cart.prototype.mapToCartOperations = function (addItems, removeItems) {
        var _this = this;
        if (addItems === void 0) { addItems = []; }
        if (removeItems === void 0) { removeItems = []; }
        var operations = [];
        removeItems.forEach(function (item) {
            operations.push({
                operation: ticketengine_sdk_1.CartOperationType.RemoveItem,
                // operation: 'RemoveItem',
                data: item
            });
        });
        addItems.forEach(function (item) {
            if (Cart.isAccessCartItem(item)) {
                operations.push({
                    operation: ticketengine_sdk_1.CartOperationType.AddAccessItem,
                    data: item
                });
            }
            else if (Cart.isProductCartItem(item)) {
                operations.push({
                    operation: ticketengine_sdk_1.CartOperationType.AddProductItem,
                    data: item
                });
            }
            else if (Cart.isBatchAccessCartItems(item)) {
                operations.push({
                    operation: ticketengine_sdk_1.CartOperationType.BatchAddAccessItems,
                    data: item
                });
            }
            else {
                // const message = this.errorMessages && this.errorMessages.unknownItemType || 'Cannot add item. Unknown item type.';
                var message = _this.getErrorMessage('unknownItemType') || 'Cannot add item. Unknown item type.';
                throw new Error(message);
            }
        });
        return operations;
    };
    Cart.prototype.getItemCount = function () {
        return __awaiter(this, void 0, void 0, function () {
            var order;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.hasOrder()) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.getOrder(this.getOrderId())];
                    case 1:
                        order = _a.sent();
                        return [2 /*return*/, order.lineItems.filter(function (item) { return item.status !== Model_1.LineItemStatus.removed && item.status !== Model_1.LineItemStatus.returned; }).length];
                    case 2: return [2 /*return*/, 0];
                }
            });
        });
    };
    Cart.prototype.addToken = function (token) {
        return __awaiter(this, void 0, void 0, function () {
            var retryPolicy, isInFinalState, hasToken, _a, _b, _c, _d, orderId;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        retryPolicy = [0, 1000, 1000, 1000];
                        isInFinalState = new OrderValidator_1.IsInFinalState();
                        hasToken = new OrderValidator_1.HasToken(token);
                        _a = !this.hasOrder();
                        if (_a) return [3 /*break*/, 3];
                        _b = this.hasOrder();
                        if (!_b) return [3 /*break*/, 2];
                        _d = (_c = isInFinalState).validate;
                        return [4 /*yield*/, this.getOrder(this.getOrderId())];
                    case 1:
                        _b = _d.apply(_c, [_e.sent()]);
                        _e.label = 2;
                    case 2:
                        _a = (_b);
                        _e.label = 3;
                    case 3:
                        if (!_a) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.createOrder()];
                    case 4:
                        _e.sent();
                        _e.label = 5;
                    case 5:
                        orderId = this.getOrderId();
                        return [4 /*yield*/, this.client.order.addOrderToken({ aggregateId: orderId, token: token }, retryPolicy)];
                    case 6:
                        _e.sent();
                        return [4 /*yield*/, this.fetchOrder(orderId, hasToken, __spreadArray([], this.retryPolicy, true))];
                    case 7:
                        _e.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Cart.prototype.acceptOffer = function (offerId) {
        return __awaiter(this, void 0, void 0, function () {
            var retryPolicy, orderId, response, validator;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        retryPolicy = [0, 1000];
                        orderId = this.getOrderId();
                        return [4 /*yield*/, this.client.offer.acceptOffer({ aggregateId: orderId, offerId: offerId }, retryPolicy)];
                    case 1:
                        response = _a.sent();
                        validator = new OrderValidator_1.ItemsHaveStatus([response.data.orderLineItemId], Model_1.LineItemStatus.reserved);
                        return [4 /*yield*/, this.fetchOrder(orderId, validator, __spreadArray([], this.retryPolicy, true))];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Cart.prototype.reserve = function (email, timeoutOn) {
        return __awaiter(this, void 0, void 0, function () {
            var canReserve, isReserved, orderId, order;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        canReserve = new OrderValidator_1.CanReserve();
                        isReserved = new OrderValidator_1.IsReserved();
                        orderId = this.getOrderId();
                        return [4 /*yield*/, this.getOrder(orderId)];
                    case 1:
                        order = _a.sent();
                        if (!canReserve.validate(order)) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.client.order.reserveOrder({
                                aggregateId: orderId,
                                timeoutOn: timeoutOn,
                                customerEmail: email
                            }, __spreadArray([], this.retryPolicy, true))];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.fetchOrder(this.getOrderId(), isReserved, __spreadArray([], this.retryPolicy, true))];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    // public async checkout(email?: string, paymentMethod?: string): Promise<CheckoutResult> {
    Cart.prototype.checkout = function (email, payments, remark, optInOn) {
        return __awaiter(this, void 0, void 0, function () {
            var paymentResults, canCheckout, canPay, isCheckedOutOrCompleted, orderId, order, index, payment, paymentResult;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        paymentResults = [];
                        canCheckout = new OrderValidator_1.CanCheckout();
                        canPay = new OrderValidator_1.CanPay();
                        isCheckedOutOrCompleted = new OrderValidator_1.HasStatus([Model_1.OrderStatus.checkOut, Model_1.OrderStatus.completed]);
                        orderId = this.getOrderId();
                        return [4 /*yield*/, this.getOrder(orderId)];
                    case 1:
                        order = _a.sent();
                        if (!canCheckout.validate(order)) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.client.order.checkoutOrder({
                                aggregateId: orderId,
                                customerEmail: email,
                                customerRemark: remark,
                                optInOn: optInOn
                            }, __spreadArray([], this.retryPolicy, true))];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.fetchOrder(this.getOrderId(), isCheckedOutOrCompleted, __spreadArray([], this.retryPolicy, true))];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        if (!(payments && payments.length > 0)) return [3 /*break*/, 8];
                        payments.sort(function (a, b) { return (a.currencyCode.length < b.currencyCode.length) ? 1 : ((b.currencyCode.length < a.currencyCode.length) ? -1 : 0); }); // sort payments so custom currency payments are create first.
                        index = 0;
                        _a.label = 5;
                    case 5:
                        if (!(index < payments.length)) return [3 /*break*/, 8];
                        payment = payments[index];
                        return [4 /*yield*/, this.createPayment(payment.currencyCode, payment.amount, payment.method, payment.token, payment.loyaltyCardType, payment.loyaltyCardId, payment.loyaltyCardPin)];
                    case 6:
                        paymentResult = _a.sent();
                        paymentResults.push(paymentResult);
                        _a.label = 7;
                    case 7:
                        index++;
                        return [3 /*break*/, 5];
                    case 8: return [2 /*return*/, { paymentResults: paymentResults }];
                }
            });
        });
    };
    // public async getAvailablePaymentMethods(): Promise<void> {
    //     // is anders voor box office als voor online
    // }
    // public getRequiredPayments(): void {
    //     // is anders voor box office als voor online
    // }
    Cart.prototype.createPayment = function (currencyCode, amount, method, token, loyaltyCardType, loyaltyCardId, loyaltyCardPin) {
        return __awaiter(this, void 0, void 0, function () {
            var customerId, paymentId, action, response, response, response, message;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        customerId = this.hasCustomerId() ? this.getCustomerId() : undefined;
                        paymentId = undefined;
                        action = undefined;
                        if (!(method === 'cash')) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.client.payment.createCashPayment({
                                orderId: this.getOrderId(),
                                currency: currencyCode,
                                amount: amount,
                                customerId: customerId
                            }, [0, 500, 1000])];
                    case 1:
                        response = _a.sent();
                        paymentId = response.data.paymentId;
                        _a.label = 2;
                    case 2:
                        if (!(method === 'pin')) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.client.payment.createPinPayment({
                                orderId: this.getOrderId(),
                                currency: currencyCode,
                                amount: amount,
                                customerId: customerId
                            }, [0, 500, 1000])];
                    case 3:
                        response = _a.sent();
                        paymentId = response.data.paymentId;
                        _a.label = 4;
                    case 4:
                        if (!(method !== 'cash' && method !== 'pin')) return [3 /*break*/, 6];
                        return [4 /*yield*/, this.client.payment.createPayment({
                                orderId: this.getOrderId(),
                                currency: currencyCode,
                                amount: amount,
                                customerId: customerId,
                                token: token,
                                paymentMethod: method,
                                loyaltyCardType: loyaltyCardType,
                                loyaltyCardId: loyaltyCardId,
                                loyaltyCardPin: loyaltyCardPin,
                                // }, [0, 500, 1000]);
                            }, [])];
                    case 5:
                        response = _a.sent();
                        paymentId = response.data.paymentId;
                        action = { paymentUrl: response.data.paymentUrl };
                        _a.label = 6;
                    case 6:
                        if (paymentId) {
                            return [2 /*return*/, { paymentId: paymentId, action: action }];
                        }
                        message = this.getErrorMessage('createPaymentFailed') || 'Create payment failed.';
                        throw new Error(message);
                }
            });
        });
    };
    Cart.prototype.getOrderId = function () {
        var orderString = localStorage.getItem("te-order");
        if (orderString) {
            var order = JSON.parse(orderString);
            return order.id;
        }
        // const message = this.errorMessages && this.errorMessages.orderNotFound || 'No order found.';
        var message = this.getErrorMessage('orderNotFound') || 'No order found.';
        throw new Error(message);
    };
    Cart.setOrder = function (order) {
        localStorage.setItem("te-order", JSON.stringify(order));
    };
    Cart.prototype.hasOrder = function () {
        return localStorage.getItem("te-order") !== null;
    };
    Cart.prototype.clearOrder = function () {
        localStorage.removeItem("te-order");
    };
    // public getOrderId(): string {
    //     const orderId = localStorage.getItem("te-order-id");
    //     if(orderId) {
    //         return orderId;
    //     }
    //     throw new Error('No order id found.');
    // }
    // private static setOrderId(orderId: string): void {
    //     localStorage.setItem("te-order-id", orderId);
    // }
    // public hasOrderId(): boolean {
    //     return localStorage.getItem("te-order-id") !== null;
    // }
    Cart.prototype.setCustomer = function (customerId) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.hasOrder() && !this.hasCustomerId())) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.client.order.assignToCustomer({
                                aggregateId: this.getOrderId(),
                                customerId: customerId
                            }, __spreadArray([], this.retryPolicy, true))];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        Cart.setCustomerId(customerId);
                        return [2 /*return*/, new Promise(function (resolve) { return resolve(); })];
                }
            });
        });
    };
    Cart.prototype.removeCustomer = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.hasOrder() && !this.hasCustomerId())) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.client.order.unassignFromCustomer({ aggregateId: this.getOrderId() }, __spreadArray([], this.retryPolicy, true))];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        localStorage.removeItem("te-customer-id");
                        return [2 /*return*/, new Promise(function (resolve) { return resolve(); })];
                }
            });
        });
    };
    Cart.setCustomerId = function (customerId) {
        localStorage.setItem("te-customer-id", customerId);
    };
    Cart.prototype.getCustomerId = function () {
        var customerId = localStorage.getItem("te-customer-id");
        if (customerId) {
            return customerId;
        }
        // const message = this.errorMessages && this.errorMessages.customerNotFound || 'No customer found.';
        var message = this.getErrorMessage('customerNotFound') || 'No customer found.';
        throw new Error(message);
    };
    Cart.prototype.hasCustomerId = function () {
        return localStorage.getItem("te-customer-id") !== null;
    };
    Cart.prototype.getSalesChannelId = function () {
        var salesChannelId = localStorage.getItem("te-sales-channel-id");
        if (salesChannelId) {
            return salesChannelId;
        }
        // const message = this.errorMessages && this.errorMessages.salesChannelNotFound || 'No sales channel found.';
        var message = this.getErrorMessage('salesChannelNotFound') || 'No sales channel found.';
        throw new Error(message);
    };
    Cart.prototype.setSalesChannelId = function (salesChannelId) {
        localStorage.setItem("te-sales-channel-id", salesChannelId);
    };
    Cart.prototype.hasSalesChannelId = function () {
        return localStorage.getItem("te-sales-channel-id") !== null;
    };
    Cart.prototype.clearSalesChannelId = function () {
        localStorage.removeItem("te-sales-channel-id");
        this.clearRegisterId();
    };
    Cart.prototype.getRegisterId = function () {
        var registerId = localStorage.getItem("te-register-id");
        if (registerId) {
            return registerId;
        }
        // const message = this.errorMessages && this.errorMessages.registerNotFound || 'No register found.';
        var message = this.getErrorMessage('registerNotFound') || 'No register found.';
        throw new Error(message);
    };
    Cart.prototype.setRegisterId = function (registerId) {
        localStorage.setItem("te-register-id", registerId);
    };
    Cart.prototype.hasRegisterId = function () {
        return localStorage.getItem("te-register-id") !== null;
    };
    Cart.prototype.clearRegisterId = function () {
        localStorage.removeItem("te-register-id");
    };
    Cart.prototype.getPreferredLanguageCode = function () {
        var preferredLanguageCode = localStorage.getItem("te-preferred-language-code");
        if (preferredLanguageCode) {
            return preferredLanguageCode;
        }
        // const message = this.errorMessages && this.errorMessages.noPreferredLanguageSet || 'No preferred language code found.';
        var message = this.getErrorMessage('noPreferredLanguageSet') || 'No preferred language code found.';
        throw new Error(message);
    };
    Cart.prototype.setPreferredLanguageCode = function (preferredLanguageCode) {
        localStorage.setItem("te-preferred-language-code", preferredLanguageCode);
    };
    Cart.prototype.hasPreferredLanguageCode = function () {
        return localStorage.getItem("te-preferred-language-code") !== null;
    };
    Cart.prototype.clearPreferredLanguageCode = function () {
        localStorage.removeItem("te-preferred-language-code");
    };
    Cart.prototype.setErrorMessages = function (errorMessages) {
        this.errorMessages = errorMessages;
    };
    Cart.prototype.getErrorMessage = function (key) {
        if (this.errorMessages && this.errorMessages[key])
            return this.errorMessages[key];
        if (window && window.teErrorMessages && window.teErrorMessages[key])
            return window.teErrorMessages[key];
        return null;
    };
    Cart.isAccessCartItem = function (item) {
        return item.eventId !== undefined && item.quantity === undefined;
    };
    Cart.isProductCartItem = function (item) {
        return item.productDefinitionId !== undefined;
    };
    Cart.isBatchAccessCartItems = function (item) {
        return item.eventId !== undefined && item.quantity !== undefined;
    };
    Cart.prototype.sleep = function (ms) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve) { return setTimeout(resolve, ms); })];
            });
        });
    };
    return Cart;
}());
exports.Cart = Cart;
